#########################################################################
#  the name of the project
#
PROJECT=mmc_1

#  List of the objects files in the project
#  Keep it current with all the source!
#
OBJECTS = $(PROJECT).o crt0.o delay.o bitbang.o uart.o nand.o

#  Path to toolchain
#
TOOL_PATH=D:/cygwin/opt/rtems-4.6/bin/

#  Here's where the compiler options can be messed up
#
GCC = arm-rtems-gcc
GCFLAGS = -Wall -nostartfiles -mcpu=arm7tdmi -O2

OBJCOPY = arm-rtems-objcopy

#########################################################################

all:: $(PROJECT).s19

$(PROJECT).s19: $(PROJECT).elf
	$(TOOL_PATH)$(OBJCOPY) -R .stack -S -O srec $(PROJECT).elf $(PROJECT).s19
	$(TOOL_PATH)$(OBJCOPY) -R .stack -S -O binary $(PROJECT).elf $(PROJECT).bin

$(PROJECT).elf: $(OBJECTS) $(PROJECT).dld
	$(TOOL_PATH)$(GCC) $(GCFLAGS) -T $(PROJECT).dld $(OBJECTS) -Xlinker -Map -Xlinker $(PROJECT).map -o $(PROJECT).elf

#########################################################################
#  Default rules to compile .c and .cpp file to .o
#  and assemble .s files to .o

.c.o :
	$(TOOL_PATH)$(GCC) $(GCFLAGS) -c $<
	$(TOOL_PATH)$(GCC) -MM -o $*.d  $<

.cpp.o :
	$(TOOL_PATH)$(GCC) $(GCFLAGS) -c $<
	$(TOOL_PATH)$(GCC) -MM -o $*.d  $<

.s.o :
	$(TOOL_PATH)$(GCC) -x assembler-with-cpp $(GCFLAGS) -Wa,-gstabs  -c $<
#########################################################################


#########################################################################
#	Optional: copy all the .d files (autodependicies from source files) to the bottom of the makefile
#	This will ensure that header file mods will force a recompile, if needed
#	To update: delete everything after this line and "cat *.d >> lcd_1.mak"

bitbang.o: bitbang.c stdint.h s3c44b0x.h delay.h bitbang.h uart.h
delay.o: delay.c stdint.h s3c44b0x.h
mmc_1.o: mmc_1.c stdint.h s3c44b0x.h delay.h bitbang.h uart.h nand.h
nand.o: nand.c stdint.h s3c44b0x.h delay.h bitbang.h uart.h nand.h
uart.o: uart.c stdint.h s3c44b0x.h
